# Security - Serie 1

## Installation

Install it yourself as:

    $ gem install file_checking

## Usage in static mode: `file_checking <task> <exception>`

**task** can have three different values:

- `indexing` (index all files but not folders in directory and sub-directories this tool is run)
- `analysing` (analyse all files but not folders in directory and sub-directories this tool is run and which files have been modified, deleted or created)
- `help` display this help message

**OPTIONAL** <exception> is the optional path of a file which indicate which file should not be indexed
Each line of the file indicate the path relative to the current directory of a file which should not be indexed.
For example, in your current directory you have the file not-to-index.txt. So you need to write in the file containing exceptions
not-to.index.txt
For prevented the file not-to-index.txt to be indexed

## Usage in interactive mode: `file_checking`

You will be prompted to choose four tasks. The thirds one are these described above. The fourth is to quit the programm
The path of the file containing the exceptions list will be asked in a second time (Leave it blank if you have none).

## Note:

* A file is modified if his content has changed but not his absolute path
* A file is created if his absolute path is not indexed
* A file is deleted if his absolute path is indexed but don't correspond with any file in current directory or sub-directories
* Indexing is based on the MD5 algorithm

## Limitations:

This program is mono-thread. For indexing a big amount of files, it can take hours

## Author:

Numa de Montmollin, Université de Fribourg